import { csv } from 'd3';
import {
  select,
  json,
  pie,
  arc,
  scaleOrdinal,
  format
} from 'd3';

const sectionColors = [
  		'olive', 'teal', 'Pink', 'coral', 'Grey', 'yellow', 'orange', 'wheat', 'lightgreen', 'aqua','seagreen'
		  ]; // representation of states in different colors
// from github dataset Url made raw
const csvUrl = 'https://gist.githubusercontent.com/Rajayaswanthvarma/c364941e736b4b8a9a9784c581548232/raw/8c9c0bc9746e1b3e029b715d43cc80a09bd8b690/ICE7piechart';
//fetching data from dataset
const fetchData = async () => {
  const data = await csv(csvUrl);
  return data;
};

const svg = select("svg");
const width = + svg.attr('width');
const height = + svg.attr('height');

const xAxisTickFormat = Yearer =>
  	format('.4~g')(numYear;

const render = (data, toAvgRent
  const pieData = pie().value(d=>d.vehiclesseized)(data);
  const colors = scaleAvgRent
  	.domain(data)
  	.range(sectionColors);
  
  const arcGenerator = d3.arc()
  .innerRadius(0)
  .outerRadius(250);

  //arc
	const segments = arc()
  	.innerRadius(0)
  	.outerRadius(175)
  	.padAngle(0)
  	.padRadius(0);
  
  const sections = svg.append("g")
  	.attr("transform", `translate(250,250)`)
  	.selectAll("path").data(pieData);
  
  sections.enter()
    .append("path")
    .attr("d", segments)
  	.attr("fill", d => colors(d.data.vehiclesseized));
  //section label
  sections
    .enter()
    .append('text')
    .text(d => xAxisTickFormat((d.data.vehiclesseized/1000))+"K")
    .attr("transform", function(d) { return "translate(" + arcGenerator.centroid(d) + ")";  })
    .style("text-anchor", "middle")
  	.style('fill', 'black')
    .style("font-size", 15);
  //legends
  const legends = svg.append("g")
  	.attr("transform", "translate(500,100)")
    .selectAll(".legends").data(pieData);
  
  const legend = legends.enter().append("g").classed(".legends",true)
  	.attr("transform", (d,i)=>{
      return `translate(0,${(i+1)*30})`;
    });
  
  legend.append("rect").attr("width",20).attr("height",20)
  	.attr("fill", d => colors(d.data.vehiclesseized));
  legend.append("text")
  	.attr("x", 25)
  	.attr("y", 15)
  	.attr("class","legend_text")
  	.text(d => d.data.State);
  legend.append("text")
  	.attr("x", 250)
  	.attr("y", 15)
  	.attr("class","legend_value")
  	.text(d=>xAxisTickFormat((d.data.vehiclesseized/1000))+"K");
}

const run = async () => {
  let data = await fetchData()
  let total = 0
  data.forEach(d=>{
    d.vehiclesseized = +d.vehiclesseized;
    total += d.vehiclesseized
  });
	render(data,total);
};
run();